//   http://msdn.microsoft.com/en-us/library/x5aw0hdf(v=vs.110).aspx

#include <windows.h>
#include <stdio.h>
#include <omp.h>

#define NUM_THREADS 4
#define CHUNK 4
#define NUM_LOOPS 45
#define SLEEP_EVERY_N 3

int main( )
{
   int i;
   int whichThread[NUM_LOOPS];

   #pragma omp parallel num_threads(NUM_THREADS)
   {
      //#pragma omp for schedule(guided)
      //#pragma omp for schedule(dynamic, CHUNK)
      //#pragma omp for schedule(dynamic)
      //#pragma omp for schedule(static, CHUNK)
      #pragma omp for schedule(static)
      for (i = 0 ; i < NUM_LOOPS ; ++i)
      {
         if ((i % SLEEP_EVERY_N) == 0)
            Sleep(0);
         whichThread[i] = omp_get_thread_num( );
      }
   }

   printf("---------------------\n");
   printf("|  index | who did  |\n");
   printf("|    i   |    %d     |\n", CHUNK);
   printf("---------------------\n");

   for (i=0; i<NUM_LOOPS; ++i)
   {
      printf("|    %3d   |    %d   |\n", i, whichThread[i]);
   }

   printf("---------------------\n");

   return 0;
}