/*
   This program mixes OpenMP style coding with SPMD style coding
   for disastrous results.
*/
#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

void initializeVector(double *v, int n, double value)
{


   #pragma omp parallel num_threads(2) // OpenMP style (automatic work sharing)
   {
      int i;
      int tid = omp_get_thread_num();
      int atid = omp_get_ancestor_thread_num( 0 );
      int level = omp_get_level();
      printf("tid = %d, atid = %d, our level = %d\n", tid, atid, level);
      #pragma omp for
         for (i = 0; i < n; i++)
            v[i] = value;
   }
}


int main(int argc, char** argv)
{
   int i;
   int n1 = 10;
   int n2 = 20;

   double *vector1 = (double*)malloc( n1 * sizeof(double) );
   double *vector2 = (double*)malloc( n2 * sizeof(double) );

   omp_set_nested(1);

   #pragma omp parallel num_threads(3)
   {
      int tid = omp_get_thread_num();
      if (tid == 0)   // SPMD style (manual work sharing)
      {
         initializeVector(vector1, n1, 42.0);
      }
      else if (tid == 1)
      {
         initializeVector(vector2, n2, 42.0);
      }
   }

   for (i = 0; i < n1; i++)
      printf("vector1[%d] = %e\n", i, vector1[i]);

   printf("\n");

   for (i = 0; i < n2; i++)
      printf("vector2[%d] = %e\n", i, vector2[i]);

   return 0;
}